commit e8ac8be0a3d56ba0a189fb970c339ac6e84769be
Author: Heiko Schlittermann (HS12-RIPE) <hs@schlittermann.de>
Date:   Mon May 3 15:53:28 2021 +0200

    Fix DANE + SNI handling (Bug 2265)
    
    Broken in d8e99d6047e709b35eabb1395c2046100d1a1dda
    Thanks to JGH and Wolfgang Breyha for contributions.

diff --git a/src/src/transports/smtp.c b/src/src/transports/smtp.c
index f26e2337a..9ee6a578a 100644
--- a/src/src/transports/smtp.c
+++ b/src/src/transports/smtp.c
@@ -2015,7 +2015,7 @@ if (continue_hostname && continue_proxy_cipher)
       {
       case OK:		sx->conn_args.dane = TRUE;
 			ob->tls_tempfail_tryclear = FALSE;	/* force TLS */
-			ob->tls_sni = sx->first_addr->domain;	/* force SNI */
+                        ob->tls_sni = sx->conn_args.host->name; /* force SNI */
 			break;
       case FAIL_FORCED:	break;
       default:		set_errno_nohost(sx->addrlist, ERRNO_DNSDEFER,
@@ -2097,7 +2097,7 @@ if (!continue_hostname)
 	  {
 	  case OK:		sx->conn_args.dane = TRUE;
 				ob->tls_tempfail_tryclear = FALSE;	/* force TLS */
-				ob->tls_sni = sx->first_addr->domain;	/* force SNI */
+				ob->tls_sni = sx->conn_args.host->name; /* force SNI */
 				break;
 	  case FAIL_FORCED:	break;
 	  default:		set_errno_nohost(sx->addrlist, ERRNO_DNSDEFER,

commit ed64b5c2f0f44db27ae48128fc97d5ad8406a28e
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue May 4 13:06:31 2021 +0100

    Fix ${ipv6norm:}
    
    (cherry picked from commit 8b4b6ac90766b11fa74fa3001778b49456adbe42)

diff --git a/src/src/host.c b/src/src/host.c
index dbc7ce20d..ee9d323a7 100644
--- a/src/src/host.c
+++ b/src/src/host.c
@@ -1197,9 +1197,9 @@ for (c = buffer, k = -1, i = 0; i < 8; i++)
   c++;
   }
 
-c[-1] = '\0';	/* drop trailing colon */
+*--c = '\0';	/* drop trailing colon */
 
-/* debug_printf("%s: D k %d <%s> <%s>\n", __FUNCTION__, k, d, d + 2*(k+1)); */
+/* debug_printf("%s: D k %d <%s> <%s>\n", __FUNCTION__, k, buffer, buffer + 2*(k+1)); */
 if (k >= 0)
   {			/* collapse */
   c = d + 2*(k+1);

commit e3311bc211d20617d90e75ea8ec7e01e6210483d
Merge: 6429b0fc7 ed64b5c2f
Author: Heiko Schlittermann (HS12-RIPE) <hs@schlittermann.de>
Date:   Sun May 9 11:25:09 2021 +0200

    Merge branch 'exim-4.94+fixes' of ssh://git.exim.org/home/git/exim into exim-4.94+fixes

commit 53b8b89b51a9b3f28b8e476528be0237c628261c
Merge: e8ac8be0a e3311bc21
Author: Heiko Schlittermann (HS12-RIPE) <hs@schlittermann.de>
Date:   Sun May 9 11:26:03 2021 +0200

    Merge branch 'exim-4.94+fixes' into exim-4.94.2+fixes
